;*****************************************************************************
;*
;*	(C) Copyright 1996-1997 Novell, Inc.
;*	All Rights Reserved.
;*
;*	This program is an unpublished copyrighted work which is proprietary
;*	to Novell, Inc. and contains confidential information that is not
;*	to be reproduced or disclosed to any other person or entity without
;*	prior written consent from Novell, Inc. in each and every instance.
;*
;*	WARNING:  Unauthorized reproduction of this program as well as
;*	unauthorized preparation of derivative works based upon the
;*	program or distribution of copies by sale, rental, lease or
;*	lending are violations of federal copyright laws and state trade
;*	secret laws, punishable by civil and criminal penalties.
;*
;*****************************************************************************
;
;	Written by Mel Oyler 1996

NEB_EVENT_VERSION1		equ	1
NEB_PRODUCER_VERSION1		equ	1
NEB_CONSUMER_VERSION1		equ	1
NEB_FILTER_VERSION1		equ	1

EVENT_BLOCK_STAMP		equ	'KLBE'	;4B4C4245h

EVENT_BLOCK_SIGNATURE		equ	'BTVE'	;42545645h

;* Includes NULL terminator
MAX_EVENT_USER_NAME_LENGTH	equ	80

MAX_FILTER_NAME_LENGTH		equ	80

;* Event flags
MAY_NOT_SLEEP_BIT		equ	00000001h
SORT_LOW_TO_HIGH_BIT		equ	00000002h
CONSUMABLE_BIT			equ	00000004h
NO_SA_BIT			equ	00000008h
NO_AUDITOR_BIT			equ	00000010h
NO_CHECK_BIT			equ	00000020h
	;Data is NESL encapsulated data
NESL_DATA_BIT			equ	00000040h
	;NESL shim's way of telling neb how to resolve bit definitions
	;with regular NEB components.
NESL_SHIM_BIT			equ	00000080h
EF_DEFINED_MASK1 equ (MAY_NOT_SLEEP_BIT OR SORT_LOW_TO_HIGH_BIT OR CONSUMABLE_BIT OR NO_SA_BIT)
EF_DEFINED_MASK2 equ (NO_AUDITOR_BIT OR NO_CHECK_BIT OR NESL_DATA_BIT OR NESL_SHIM_BIT)
EF_UNDEFINED_MASK equ NOT (EF_DEFINED_MASK1 OR EF_DEFINED_MASK2)
DATA_FILTERED_BIT		equ	80000000h

;* ProducerFlags
UNIQUE_PRODUCER_BIT		equ	00000001h

;* ConsumerFlags
CONSUMABLE_CONSUMER_BIT		equ	00000001h
ACCESS_CONTROL_CHECK_BIT	equ	00000002h

;* Shared (Producer/Consumer)Flags
EVENT_CLASS_BIT			equ	40000000h
SMP_ENABLED_BIT			equ	80000000h

;* User types
PRODUCER			equ	0
SECURITY_AUTHORITY_CONSUMER	equ	1
AUDITOR_CONSUMER		equ	2
CHECK_CONSUMER			equ	3
SYNCHRONOUS_CONSUMER		equ	4
ASYNCHRONOUS_CONSUMER		equ	5
DEBUG_CONSUMER		 	equ	6
RESERVED			equ	7

;* Consumer Notify type codes
NOTIFY_AUDITOR			equ	0

VALIDATE_PRODUCER_REGISTRATION		equ	1
VALIDATE_CHECK_CONSUMER_REGISTRATION	equ	2
VALIDATE_SYNC_CONSUMER_REGISTRATION	equ	3
VALIDATE_ASYNC_CONSUMER_REGISTRATION	equ	4

NOTIFY_SECURITY_AUTHORITY		equ	5
VERIFY_CHECK_CONSUMER			equ	6
VERIFY_SYNC_CONSUMER			equ	7
VERIFY_ASYNC_CONSUMER			equ	8

NOTIFY_CHECK_CONSUMER			equ	9
NOTIFY_SYNCHRONOUS_CONSUMER		equ	10
NOTIFY_ASYNCHRONOUS_CONSUMER		equ	11
NOTIFY_DEBUGGER				equ	12

NOTIFY_PRODUCER_UNREGISTRATION		equ	13
NOTIFY_CHECK_CONSUMER_UNREGISTRATION	equ	14
NOTIFY_SYNC_CONSUMER_UNREGISTRATION	equ	15
NOTIFY_ASYNC_CONSUMER_UNREGISTRATION	equ	16

NOTIFY_REGISTRATION_FAILED		equ	17

NOTIFY_PROD_OF_CONS_REG			equ	18
NOTIFY_PROD_OF_CONS_DEREG		equ	19

NOTIFY_CONS_OF_PROD_REG			equ	20
NOTIFY_CONS_OF_PROD_DEREG		equ	21

ADD_CONS_TO_FILTER			equ	22
REMOVE_CONS_FROM_FILTER			equ	23
VALIDATE_FILTER				equ	24
NOTIFY_FILTER				equ	25

SIDE_BAND_MESSAGE			equ	26

;* Consumer ESR ccodes
;* Security Authority, Auditor, and Check Consumers ESR ccodes
ACCESS_APPROVED			equ	00000000h
ACCESS_DENIED			equ	00000001h
FUNCTION_NOT_SUPPORTED		equ	80000000h

;* Synchronous consumer ESR ccodes
EVENT_NOT_CONSUMED		equ	00000000h
EVENT_CONSUMED			equ	00000001h
;FUNCTION_NOT_SUPPORTED		equ	80000000h

;* Produce Event ccodes
SUCCESS				equ	0
INVALID_PARAMETER		equ	0FFFFFFFFh	;-1
EVENT_DENIED			equ	0FFFFFFFEh	;-2

;* Send Event ccodes
;SUCCESS				equ	0
;INVALID_PARAMETER		equ	0FFFFFFFFh	;-1
SIDEBAND_NOT_SUPPORTED		equ	0FFFFFFFEh	;-2

;* RegisterProducer ccodes
;SUCCESS				equ	0
;INVALID_PARAMETER		equ	0FFFFFFFFh	;-1
NEB_OUT_OF_RESOURCES		equ	0FFFFFFFEh	;-2
EVENT_CONFLICT			equ	0FFFFFFFDh	;-3
REGISTRATION_DENIED		equ	0FFFFFFFCh	;-4
PRODUCER_NOT_UNIQUE		equ	0FFFFFFFBh	;-5

;* RegisterConsumer ccodes
;SUCCESS				equ	0
;INVALID_PARAMETER		equ	0FFFFFFFFh	;-1
;NEB_OUT_OF_RESOURCES		equ	0FFFFFFFEh	;-2
;EVENT_CONFLICT			equ	0FFFFFFFDh	;-3
;REGISTRATION_DENIED		equ	0FFFFFFFCh	;-4
CONSUMER_ALREADY_REGISTERED	equ	0FFFFFFFBh	;-5
INVALID_CONSUMER_TYPE		equ	0FFFFFFFAh	;-6
INVALID_FILTER			equ	0FFFFFFF9h	;-7

;* RegisterFilter ccodes
;SUCCESS				equ	0
;INVALID_PARAMETER		equ	0FFFFFFFFh	;-1
;NEB_OUT_OF_RESOURCES		equ	0FFFFFFFEh	;-2
DUPLICATE_FILTER		equ	0FFFFFFFDh	;-3



EventBlock	struc
	EBVersion		dd	?
	EBStamp			dd	?
	EBILink			dd	?
	EBRTag			dd	?

	EBLink			dd	?
	EBProducerID		dd	?
	EBProducerWorkSpace	dd	?
	EBConsumingConsumer	dd	?

	EBEventDataLength	dd	?
	EBEventData		dd	?
	EBShortData1		dd	?
	EBShortData2		dd	?

	EBShortData3		dd	?
	EBShortData4		dd	?
	EBEventNotifyType	dd	?
	EBUserParameter		dd	?

	EBParm0			dd	?
	EBParm1			dd	?
	EBEventFlags		dd	?
	EBReserved		db	?

EventBlock	ends

ProducerRegistrationInfo	struc
	PRIVersion		dd	?
	PRIProducerName		dd	?
	PRIEventName		dd	?
	PRIUserParameter	dd	?

	PRIEventFlags		dd	?
	PRIOwnerID		dd	?
	PRIProducerESR		dd	?
	PRISecurityToken	dd	?

	PRIProducerFlags	dd	?
	PRIPriority		dd	?
	PRIEventID		dd	?
	PRIProducerID		dd	?
ProducerRegistrationInfo	ends

ConsumerRegistrationInfo	struc
	CRIVersion		dd	?
	CRIConsumerName		dd	?
	CRIEventName		dd	?
	CRIUserParameter	dd	?

	CRIEventFlags		dd	?
	CRIOwnerID		dd	?
	CRIConsumerESR		dd	?
	CRISecurityToken	dd	?

	CRIConsumerFlags	dd	?
	CRIFilterName		dd	?
	CRIFilterDataLength	dd	?
	CRIFilterData		dd	?

	CRIConsumerCallback	dd	?
	CRIConsumerType		dd	?
	CRIOrder		dd	?
	CRIConsumerID		dd	?
ConsumerRegistrationInfo	ends

FilterRegistrationInfo	struc
	FRIVersion		dd	?
	FRIFilterName		dd	?
	FRIOwnerID		dd	?
	FRIFilterESR		dd	?

	FRIFilterID		dd	?
FilterRegistrationInfo	ends

;*****************************************************************************
;*****************************************************************************

