%PAGESIZE 66,130
;*****************************************************************************
;  NESL.INC
;
;	(c) Copyright Unpublished Work of Novell, Inc. All Rights Reserved
;  
;	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
;	PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.   
;	ACCESS TO THIS WORK IS RESTRICTED TO (i) NOVELL EMPLOYEES  
;	WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE  
;	OF THEIR ASSIGNMENTS AND (ii) ENTITIES OTHER THAN NOVELL   
;	WHO HAVE ENTERED INTO APPROPRIATE LICENSE AGREEMENTS.      
;	NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,
;	DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,      
;	CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,  
;	TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF
;	NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION
;	COULD SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.
;
;*****************************************************************************
;
;	General data structure definitions used by the Event Service
;	Layer.
;
;	Written by:	WTT
;	Date:		8/11/93
;
; Modification History:
;
; April 1, 1996	JWR	v1.04
;		Added ISO Stack Defines to assist in getting the request numbers correct.
;
;*****************************************************************************

;----------------------------------------------------------------------------
;	Consumer Control Block Structure
;----------------------------------------------------------------------------

CECB	struc
	CECB_MajVer		dw	1	; Major Version number
	CECB_MinVer		dw	0	; Minor Version Number
	CECB_NextConsumer	dd	0	; Ptr to next block
	CECB_ClassName		dd	0	; Ptr to class name
	CECB_NotifiProc		dd	0	; Address of Notification Procedure
	CECB_OSILevel		dw	0	; OSI level of consumer.
	CECB_Reserved		db	14 dup (0)
CECB	ends

;----------------------------------------------------------------------------
;	Producer Control Block Structure
;----------------------------------------------------------------------------
PECB	struc
	PECB_MajVer		dw	1	; Major Version number
	PECB_MinVer		dw	0	; Minor Version Number
	PECB_NextProducer	dd	0	; Ptr to next block
	PECB_ClassName		dd	0	; Ptr to class name
	PECB_ConsumerList	dd	0	; Ptr to consumer list
	PECB_DataPtr		dd	0	; Ptr to additional information
	PECB_Flags		dd	0	; bit 0 = calling direction 
	PECB_Reserved		db	8 dup (0)
PECB	ends

;----------------------------------------------------------------------------
;	Event Parameter Block Structure
;----------------------------------------------------------------------------
EPB	struc
	EPB_MajVer		dw	1	; Major Version number
	EPB_MinVer		dw	0	; Minor Version Number
	EPB_ClassName		dd	0	; Ptr to class name
	EPB_EventName		dd	0	; Ptr to name of the specific event
	EPB_ModuleName		dd	0	; Ptr to the modules name
	EPB_DataPtr0		dd	0	; Ptr to additional information
	EPB_DataPtr1		dd	0	; Ptr to additional information
	EPB_Reserved		db	8 dup (0)
EPB	ends

;----------------------------------------------------------------------------
;	NESL Functions
;----------------------------------------------------------------------------
NESL_GET_CONFIG_PTR	equ	0
NESL_REG_PRODUCER	equ	1
NESL_DEREG_PRODUCER	equ	2
NESL_EVENT_NOTIFICATION equ	3
NESL_REG_CONSUMER	equ	4
NESL_DEREG_CONSUMER	equ	5

;----------------------------------------------------------------------------
;	General OSI Stack Definitions for CECB_OSILevel
;----------------------------------------------------------------------------
NESL_APPLICATION_LAYER	equ	70h
NESL_PRESENTATION_LAYER	equ	60h
NESL_SESSION_LAYER	equ	50h
NESL_TRANSPORT_LAYER	equ	40h
NESL_NETWORK_LAYER	equ	30h
NESL_DATALINK_LAYER	equ	20h
NESL_PHYSICAL_LAYER	equ	10h
