;****************************************************************************
; BMICSTRU.INC 
;
;  Copyright Unpublished Work of Novell, Inc. All Rights Reserved
;  
;  THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
;  PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.   
;  ACCESS TO THIS WORK IS RESTRICTED TO (i) NOVELL EMPLOYEES  
;  WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE  
;  OF THEIR ASSIGNMENTS AND (ii) ENTITIES OTHER THAN NOVELL   
;  WHO HAVE ENTERED INTO APPROPRIATE LICENSE AGREEMENTS.      
;  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,
;  DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,      
;  CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,  
;  TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF
;  NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION
;  COULD SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.
;****************************************************************************
;	
;	Title:		BMIC Structures and Equates for the Adapter Side
;	FileName:	BMICStru.inc
;	Date: 		November 2, 1991
;	Written By:	Jon Rosdahl
;
;****************************************************************************

include	BMTCB.inc	; Included for the Post office Messages mainly.

;----------------------------------------------------------------------------
;BMIC Registers --- Local Register Addresses (80186's PCS4 port)
;----------------------------------------------------------------------------

BMIC_Data		equ	200h		; BMIC Data port 
BMIC_Index		equ	202h		; BMIC Index Port
BMIC_Status		equ	204h		; BMIC Status/Control Port 
AUTO_INC		equ	 80h		; Index Auto Increment Bit.

;----------------------------------------------------------------------------
;	BMIC_Status Bit Values
;----------------------------------------------------------------------------

LOCAL_INT_PENDING	equ	80h
CH1_INT_PENDING		equ	40h
CH0_INT_PENDING		equ	20h
LOCAL_INT_ENABLED	equ	10h
LOCAL_INT_ACTIVE	equ	08h
PEEK_POKE_PENDING	equ	04h
CH1_BASE_BUSY		equ	02h
CH0_BASE_BUSY		equ	01h

;----------------------------------------------------------------------------
; 	MailBox Registers Generic Index (Local Addresses)
;----------------------------------------------------------------------------

MAIL_0			equ	10h		; BMIC MailBox 0.
MAIL_4			equ	14h		; BMIC MailBox 4.
MAIL_5			equ	15h		; BMIC MailBox 5
MAIL_6			equ	16h		; BMIC MailBox 6
MAIL_8			equ	18h		; BMIC MailBox 8.
MAIL_C			equ	1Ch		; BMIC MailBox 0C.

;----------------------------------------------------------------------------
;	MailBox Assignments    (Post Office)
;----------------------------------------------------------------------------

VALID_RCB_MAILBOX	equ	MAIL_0 		; BMIC MailBox 0. (LookAhead is clear).
ABEND_IDLE_MAILBOX	equ	MAIL_0 + 1	; BMIC MailBox 1. (0F0h = Abend, 00Fh = Idle)
PARM_UPDATE_MAILBOX	equ	MAIL_0 + 2	; BMIC MailBox 2. (04h = MC 01h = Reinit Parameter Table, 02h = ResetAdapter)
VALID_TCB_MAILBOX	equ	MAIL_0 + 3	; BMIC MailBox 3. (# frags in BMTCBstruc)
BMTCB_BYTES_MAILBOX	equ	MAIL_4		; BMIC MailBox 4. Actual number of bytes to move Hi-Lo Word order. 4=hi 5=lo
RCBOS2_MAILBOX		equ	MAIL_8		; BMIC MAilBox 8. Physical Address of RCB.
PARAMETER_MAILBOX	equ	MAIL_C		; BMIC MailBox 0Ch.

;----------------------------------------------------------------------------
; Channel 0 index registers
;----------------------------------------------------------------------------

CH0_BASE_COUNT		equ	40h
CH0_BASE_ADDR		equ	43h
CH0_CONFIG		equ	48h
CH0_STROBE		equ	49h
CH0_STATUS		equ	4Ah
CH0_TBI_BASE_ADDR	equ	4Bh

;----------------------------------------------------------------------------
; Bit values for CHx_BASE_COUNT+2
;----------------------------------------------------------------------------
 
AUTO_START		equ	80h
ADAPTER_TO_EISA		equ	40h

;
; Bit values for CHx_STATUS
;

FIFO_STALLED		equ	10h
TRANSFER_ENABLED	equ	08h
TRANSFER_IN_PROGRESS	equ	04h
TRANSFER_TERMINATED	equ	02h
;;;;;TRANSFER_COMPLETE	equ	01h
TRANSFER_COMPLETE	equ	0Ch
;
; Peek/Poke index registers.
;
PEEK_POKE_DATA		equ	30h
PEEK_POKE_ADDR		equ	34h
PEEK_POKE_CONTROL	equ	38h
;
; EISA Doorbell index registers.
;
EISA_DOORBELL_ENABLE	equ	0Eh
EISA_DOORBELL_STATUS	equ	0Fh


