page ,130
;***********************************************************************\
;
;       (c) Unpublished Work of Novell, Inc.  All rights reserved.
;  
;       THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
;       PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS 
;       TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A 
;       NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS 
;       AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO 
;       APPROPRIATE LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED,
;       PRACTICED, PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED, 
;       TRANSLATED, ABRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED, 
;       LINKED, RECAST, TRANSFORMED, OR ADAPTED WITHOUT THE PRIOR WRITTEN
;       CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT
;       AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL
;       LIABILITY.
;
;***********************************************************************\
;
;
;
;       Novell Hardware Specific Module Shim Include File
;
;       Written by:     JRT
;       Date Started:   May 4, 1995
;
;
;***********************************************************************
;
;       Many of the names and structures defined here are available in
;       the include files: MSM.INC, MSMSTRUC.INC, and ODI.INC.  These
;       include files were NOT used because of 1) name conflicts caused
;       throughout the code and 2) the include files are nested and us
;       realative path addressing requiring a specific directory
;       structure to use.
;
;***********************************************************************
;
; History Log:
;
; 05-04-95 jrt  Version 1.00
;               Coding commenced.
;
; 10-04-95 jrt  Version 1.00
;               Initial release to source control.
;
; 10-10-95 jrt  Version 1.01
;               Modifications to split common portions of shim from
;               topology specific portions.  Added CTSMModuleHandle.
;
; 10-08-96 mcd  Version 1.02
;               Added negative offset from AdapterDataSpace ptr to
;               MSM's VirtualBoardLink array and updated DriverBlockStructure
;               to current spec level.
;
; 10-25-96 jrt	Version 1.03
;		Added additional structures for ISR2 support.
;
; 11-27-96 jrt  Version 1.04
;               Modified timer structure and position and values.
;
; 02-06-97 jrt  Modified MAX_BOARDS to indicate maximum number of logical
;               boards rather than maximum number of physical boards.
;               Value changed from maximum of 4 physical to maximum or
;               256 logical.
;
; 05-02-97 jrt  Removed CTSMModuleHandle and NextShimDataSpace.
;
; 02-03-98 jrt  Added HSMIFLevel constant and set to 111 for 1.11 Spec.
;
; 02-04-98 mcd  Modified CTCBStructure to remove CTCBLink.
;
; 12-03-98 jrt	Added MSMDefaultVirtualBoard negative offset from ADS.
;
; 02-11-00 mcd  Add assembly version of CMSM_CONFIG_TABLE for use in the shim.
;               Updated HSMIFLevel to 1.20 and added Aux Data Block structures.
;
;***********************************************************************\

HSMIFLevel                      equ     120     ; C HSM Spec version 1.20

MM_C_HSM_BIT                    equ     0800h   ; CHSM bit in Config Table Mode Flags.

ODISTAT_SUCCESSFUL              equ	0
ODISTAT_RESPONSE_DELAYED        equ	1
ODISTAT_SUCCESS_TAKEN           equ	2
ODISTAT_BAD_COMMAND             equ	-127
ODISTAT_BAD_PARAMETER           equ	-126
ODISTAT_DUPLICATE_ENTRY         equ	-125
ODISTAT_FAIL                    equ	-124
ODISTAT_ITEM_NOT_PRESENT        equ	-123
ODISTAT_NO_MORE_ITEMS           equ	-122
ODISTAT_NO_SUCH_DRIVER          equ	-121
ODISTAT_NO_SUCH_HANDLER         equ	-120
ODISTAT_OUT_OF_RESOURCES        equ	-119
ODISTAT_RX_OVERFLOW             equ	-118
ODISTAT_TRANSMIT_FAILED         equ	-116
ODISTAT_PACKET_UNDELIVERABLE    equ	-115
ODISTAT_CANCELED                equ	-4

;;970206 JRT begin
;MAX_BOARDS      equ	4
MAX_BOARDS      equ	256
;;970206 JRT end
MAX_STACKS      equ	4
CACS_TCB_SIZE   equ	128

;
;***************************************************************\
;                                                               *
; ParseDriverParameters NeedsIO bit definitions.		*
;                                                               *
;***************************************************************/
;
NeedsIOSlotBit		equ	1h
NeedsIOPort0Bit		equ	2h
NeedsIOLength0Bit	equ	4h
NeedsIOPort1Bit		equ	8h
NeedsIOLength1Bit	equ	10h
NeedsMemoryDecode0Bit	equ	20h
NeedsMemoryLength0Bit	equ	40h
NeedsMemoryDecode1Bit	equ	80h
NeedsMemoryLength1Bit	equ	100h
NeedsInterrupt0Bit	equ	200h
NeedsInterrupt1Bit	equ	400h
NeedsDMA0Bit		equ	800h
NeedsDMA1Bit		equ	1000h
NeedsChannelBit		equ	2000h
CAN_SET_NODE_ADDRESS	equ	40000000h
MUST_SET_NODE_ADDRESS	equ	80000000h

;
;***************************************************************\
;                                                               *
; CHSM Statistic Counters Structures.                           * 
;                                                               *
;***************************************************************/
;

StatisticTable		struc

CMStatTableMajorVersion	dw	?
CMStatTableMinorVersion	dw	?
CMNumGenericCounters	dd	?
CMGenericCountersPtr	dd	?
CMNumMediaCounters	dd	?
CMMediaCountersPtr	dd	?
CMNumCustomCounters	dd	?
CMCustomCountersPtr	dd	?

StatisticTable		ends


StatTableEntry		struc

StatUseFlag		dd	?
StatCounter		dd	?
StatString		dd	?

StatTableEntry		ends


;;JRT 961127 begin
; values for StatUseFlag - ODI Statistics Counter Type
ODI_STAT_UNSUSED        equ 	0FFFFFFFFh
ODI_STAT_UINT32         equ 	00000000h       ; only type supported by shim
ODI_STAT_UINT64         equ 	00000001h
ODI_STAT_MEON_STRING    equ     00000002h
ODI_STAT_UNTYPED        equ     00000003h
;;JRT 961127 end


;
;***************************************************************\
;                                                               *
; Timer Callback equates and structures                         * 
;                                                               *
;***************************************************************/
;

AES_TYPE_PRIVILEGED_ONE_SHOT    equ	0
AES_TYPE_PRIVILEGED_CONTINUOUS  equ	1
AES_TYPE_PROCESS_ONE_SHOT       equ	2
AES_TYPE_PROCESS_CONTINUOUS     equ	3

AES             struc

AESnextLink     dd      ?
AESfunctionPtr  dd      ?
AEStype         dd      ?
AESinterval     dd      ?
AEScontext      dd      ?
AESreserved     db      30 dup (?)

AES             ends


AESProcess      struc

ALink           dd      ?
AWakeUpDelay    dd      ?
AWakeUpTime     dd      ?
AProcessToCall  dd      ?
ARTag           dd      ?
AOldLink        dd      ?

AESProcess      ends


TimerNodeData   struc

TLink           dd      ?
TCallBackProc   dd      ?
TCallBackEBX    dd      ?
TCallBackWait   dd      ?
TRTag           dd      ?
TReserved1      dd      ?
TReserved2      dd      ?

TimerNodeData   ends

;
;***************************************************************\
;                                                               *
; Parse Parameter Block Structure                               * 
;                                                               *
;***************************************************************/
;
ParseBlkStructure           struc
        PBlkLink            dd      ?
        PBlkParseString     dd      ?
        PBlkParameter0      dd      ?
        PBlkParameter1      dd      ?
        PBlkParameter2      dd      ?
        PBlkType            dw      ?
        PBlkFlags           dw      ?
        PBlkString          db      80 dup(?)
ParseBlkStructure           ends

;
;***************************************************************\
;                                                               *
; Driver Block Structure.                                       * 
;                                                               *
;***************************************************************/
;
DriverBlockStructure            	struc
        DPSize                          dd      ?
        DPStackPointer                  dd      ?
        DPModuleHandle                  dd      ?
        DPBoardPointer                  dd      ?
        DPAdapterPointer                dd      ?
        DPConfigTemplate                dd      ?
        DPFirmwareSize                  dd      ?
        DPFirmwareBuffer                dd      ?
        DPNumKeywords                   dd      ?
        DPKeywordText                   dd      ?
        DPKeywordTextLen                dd      ?
        DPProcessKeywordTab             dd      ?
        DPAdapterDataSpaceSize          dd      ?
        DPAdapterDataSpaceTemplate      dd      ?
        DPStatisticsTable               dd      ?
        DPEndOfChainFlag                dd      ?
        DPSendWantsECBs                 dd      ?
        DPMaxMulticast                  dd      ?
        DPNeedsBelow16Meg               dd      ?
        DPAES                           dd      ?
        DPCallBack                      dd      ?
        DPISR                           dd      ?
        DPMulticastChange               dd      ?
        DPPoll                          dd      ?
        DPReset                         dd      ?
        DPSend                          dd      ?
        DPShutdown                      dd      ?
        DPTxTimeout                     dd      ?
        DPPromiscuousChange             dd      ?
        DPStatisticsChange              dd      ?
        DPRxLookAheadChange             dd      ?
        DPManagement                    dd      ?
        DPEnableInterrupt               dd      ?
        DPDisableInterrupt              dd      ?
        DPISR2				dd      0
        DPBReserved2                    dd      0       ; unused in ASM HSMs see CHSM spec
        HSMSpecVersionString            dd      0       ; set before MSMRegisterHardwareOptions
        DPDriverPriorityQueuePtr        dd      0
	DPDisableInterrupt2		dd	?
DriverBlockStructure           		 ends

	page
;
;***************************************************************\
;                                                               *
; Driver Configuration structure.								*
;                                                               *
;***************************************************************/
;
MLIDConfigurationStructure	struc
	MLIDCFG_Signature	db	26 dup (?)
	MLIDCFG_MajorVersion	db	?
	MLIDCFG_MinorVersion	db	?
	MLIDNodeAddress		db	6 dup (?)
	MLIDModeFlags		dw	?
	MLIDBoardNumber		dw	?
	MLIDBoardInstance	dw	?
	MLIDMaximumSize		dd	?
	MLIDMaxRecvSize		dd	?
	MLIDRecvSize		dd	?
	MLIDCardName		dd	?
	MLIDShortName		dd	?
	MLIDFrameType		dd	?
	MLIDReserved0		dw	?
	MLIDFrameID		dw	?
	MLIDTransportTime	dw	?
	MLIDRouteHandler	dd	?
	MLIDLineSpeed		dw	?
	MLIDLookAheadSize	dw	?
	MLIDCFG_SGCount         db	?
	MLIDReserved1		db	7 dup (?)
	MLIDMajorVersion	db	?
	MLIDMinorVersion	db	?
	MLIDFlags		dw	?
	MLIDSendRetries		dw	?
	MLIDLink		dd	?
	MLIDSharingFlags	dw	?	
	MLIDSlot		dw	?
	MLIDIOPortsAndLengths	dw	4 dup (?)
	MLIDMemoryDecode0	dd	?
	MLIDLength0		dw	?
	MLIDMemoryDecode1	dd	?
	MLIDLength1		dw	?
	MLIDInterrupt		db	2 dup (?)
	MLIDDMAUsage		db	2 dup (?)
	MLIDResourceTag		dd	?
	MLIDConfig		dd	?
	MLIDCommandString	dd	?
	MLIDLogicalName		db	18 dup (?)
	MLIDLinearMemory0	dd	?
	MLIDLinearMemory1	dd	?
	MLIDChannelNumber	dw	?
	MLIDBusTag              dd	?
	MLIDIOCfgMajorVersion   db	?
	MLIDIOCfgMinorVersion   db	?
MLIDConfigurationStructure	ends

	page
;
;***************************************************************\
;                                                               *
; Media Parameter Block Structure.    			        *
;                                                               *
;***************************************************************/
;
MediaParameterBlock                 struc
    MediaParameterSize              dd      ?
    MediaConfigLimits               dd      ?
    MediaFrameDescriptTable         dd      ?
    MediaProtocolIDArray            dd      ?
    MediaIDArray                    dd      ?
    MediaHeaderSizeArray            dd      ?
    MediaSendRoutineArray           dd      ?
    MediaAdapterDataSpaceSize       dd      ?
    MediaAdapterDataSpaceTemplate   dd      ?
    MediaAdjustRecvSize             dd      ?
    MediaInit                       dd      ?
    MediaReset                      dd      ?
    MediaShutdown                   dd      ?
    MediaDriverSend                 dd      ?
    MediaGetNextSend                dd      ?
    MediaAddMulticast               dd      ?
    MediaDeleteMulticast            dd      ?
    MediaNodeOverride               dd      ?
    MediaAdjustNodeAddress          dd      ?
    MediaSetLookAheadSize           dd      ?
    MediaPromiscuousChange          dd      ?
    MediaRegisterReceiveMonitor     dd      ?
MediaParameterBlock                 ends

	page
;
;***************************************************************\
;                                                               *
; Configuration Limits Structure              			*
;                                                               *
;***************************************************************/
;
ConfigLimits            struc
    MinNodeAddress      dd      ?
    MaxNodeAddress      dd      ?
    MinRetries          dd      ?
    MaxCRetries         dd      ?
    NumberFrames        dd      ?
ConfigLimits            ends

		page
;
;***************************************************************\
;                                                               *
; Frame Data Space Preamble                 			*
;                                                               *
;***************************************************************/
;
MSMFrameDataSpace           struc
    AdapterLink             dd      ?
    InternalMediaID         dd      ?
    MediaHeaderSize         dd      ?
    PacketType              db      6 dup (?)
    BitSwapAddressFlag      db      ?
    MediaSendRoutine        dd      ?
    MediaParmBlockPtr	    dd	    ?
    MediaReserved0	    dd	    ?
    MediaReserved1	    dd	    ?
    MediaReserved2	    dd	    ?
    MediaReserved3	    dd	    ?
    MSMDriverControlJump    db      0FFh, 15h ; Absolute Call Indirect
                            dd      ?
    MSMDriverSendJump       db      0FFh, 15h
                            dd      ?
    CustomJump1             db      0FFh, 15h
                            dd      ?
    CustomJump2             db      0FFh, 15h
                            dd      ?
    CustomJump3             db      0FFh, 15h
                            dd      ?
    CustomJump4             db      0FFh, 15h
                            dd      ?
    CustomJump5             db      0FFh, 15h
			    dd      ?
    AlignEndVB      db      (4 - OFFSET (AlignEndVB and 3)) and 3 dup (0)
MSMFrameDataSpace           ends
FrameSize                   equ     SIZE MSMFrameDataSpace

		page
;
;***************************************************************\
;                                                               *
;	MLID Statistics Table 		                        *
;                                                               *
;***************************************************************/
;
MLIDStatStructure		struc
	MStatTableMajorVer	db	?
	MStatTableMinorVer	db	?
	MNumGenericCounters	dw	?
	MCounterMask0		dd	?
	MTotalTxPackets		dd	?
	MTotalRxPackets		dd	?
	MNoECBsAvailable	dd	?
	MTxTooBig		dd	?
	MTxTooSmall		dd	?
	MRxOverflow		dd	?	; HSM
	MRxTooBig		dd	?
	MRxTooSmall		dd	?
	MTxMiscError		dd	?	; HSM
	MRxMiscError		dd	?	; HSM
	MTxRetryCount		dd	?	; HSM
	MRxChecksumError	dd	?	; HSM
	MRxMismatchError	dd	?
	MTotalTxOKByteLow	dd	?
	MTotalTxOKByteHigh	dd	?
	MTotalRxOKByteLow	dd	?
	MTotalRxOKByteHigh	dd	?
	MTotalGroupAddrTx	dd	?
	MTotalGroupAddrRx	dd	?
	MAdapterReset		dd	?	; HSM
	MAdapterOprTimeStamp	dd	?
	MQDepth			dd	?
	MediaStat0		dd	?	; HSM all MediaStats
	MediaStat1		dd	?
	MediaStat2		dd	?
	MediaStat3		dd	?
	MediaStat4		dd	?
	MediaStat5		dd	?
	MediaStat6		dd	?
	MediaStat7		dd	?       ; last ethernet counter
	MediaStat8		dd	?
	MediaStat9		dd	?
	MCounterMask1		dd	?
	MediaStat10		dd	?
	MediaStat11		dd	?       ; last FDDI counter
	MediaStat12		dd	?
	MediaStat13		dd	?       ; last token ring counter
MLIDStatStructure		ends

    page
;
;***************************************************************\
;                                                               *
; TCB Structure used by CHSMs                                   * 
;                                                               *
;***************************************************************/
;
CTCBStructure               struc
;980204 mcd start
;The following field exists in the C toolkit but not in the C shim
; of the ASM toolkit
;       CTCBLink            dd      ?   ;

;980204 mcd end

        CTCBReserved        dd      ?   ; List link/org TCB ptr
        CTCBBoardNumber     dd      ?   ;
        CTCBDriverWS        dd      3 dup(?)    ;
        CTCBDataLen         dd      ?   ;
        CTCBFragStrucPtr    dd      ?   ;
        CTCBMediaHeaderSize dd      ?   ;
CTCBStructure               ends

;980204 mcd start

;***************************************************************\
;                                                               *
; Receive Event Control Block structure.  Here for the          *
; MSMGetCTCB macro.                                             *
;                                                               *
;***************************************************************/
;
ReceiveBufferStructure	struc
	RLink			dd	?
	RBLink			dd	?
	RStatus			dw	?
	RESRAddress		dd	?
	RLogicalID		dw	?
	RProtocolID		db	6 dup (?)
	RBoardNumber		dd	?
	RImmediateAddress	db	6 dup (?)
	RDriverWorkSpace	dd	?
	RProtocolWorkspace	db	8 dup (?)
	RPacketLength		dd	?
	RFragmentCount		dd	?	;always 1
	RPacketOffset		dd	?
	RPacketSize		dd	?

ReceiveBufferStructure	ends

;980204 mcd end

		page
;*************************************************************************
;
;	Shim's Adapter Data Space Template
;
;*************************************************************************

CHSMp       equ     44              ; Location in common space of ptr to
                                    ;      shim's adapter data space
;;JRT 961127 STAT_TABLE_PAD_SIZE	equ	1024

ShimAdapterDataSpace          struc ; Structure of Shim's Adapter Data Space
	AdapterDataSpacePtr       dd  ? ; Ptr to CHSM Adapter Data Space
	AdapterDataSpaceTemplate  dd  ? ; Ptr to CHSM Adapter Data Space Temp
	AdapterDataSpaceSize      dd  ? ; Size of CHSM Adapter Data Space Temp
	DriverStatTablePtr        dd  ? ; Offset to CHSM Statistics Table
	DriverParameterBlockPtr   dd  ? ; Ptr to CHSM Driver Parameter Block Temp
	DriverConfigTemplatePtr   dd  ? ; Ptr to CHSM Configuration Table Temp
    	DefaultFrameTablePtr      dd  ? ; Ptr to default Config/Frame Table
	GeneralCountersPtr	  dd  ? ; Offset to CHSM General Counters
	MediaCountersPtr  	  dd  ? ; Offset to CHSM Media Counters
    	CustomCountersPtr         dd  ? ; Offset to CHSM Custom Counters
        CustomCountersStringsPtr  dd  ? ; Pointer to Custom CTR Strings ;;JRT 961127
    	ShimCustomCountersPtr     dd  ? ; Offset to Shim's Custom Counters
	ShimAdapterDataSpaceTemp  dd  ? ; Ptr to Shim's Adapter Data Space Temp
    	DriverAESBasePtr          dd  ? ; Ptr to DriverAES function list
    	DriverINTBasePtr          dd  ? ; Ptr to DriverINT function list
    	DriverModuleHandle        dd  ? ; Handle for the driver NLM
    	DriverScreenHandle        dd  ? ; Handle for writting to screen
    	DriverCommandLine         dd  ? ; Ptr to drivers command line
    	DriverFileHandle          dd  ? ; File Handle during DriverInit
    	DriverFileRead            dd  ? ; FileRead() function adr during DriverInit
    	DriverMessageBuffer       dd  ? ; location of driver msgs
;;970214 JRT Begin
;;    	DriverAESRTag             dd  ? ; Drivers AES Resource Tag
;;    	DriverINTRTag             dd  ? ; Drivers INT Resource Tag
                                  dd  ? ; Spare 1
                                  dd  ? ; Spare 2
;;970214 JRT End
;;970502 JRT Begin
;;    	CTSMModuleHandle          dd  ? ; Module Handle of xNWCACS.NLM in use
;;    	NextShimDataSpace         dd  ? ; Ptr to next data space in chain
                                  dd  ? ; Spare 5
                                  dd  ? ; Spare 6
;;970502 JRT End
    	ShimTCBHead               dd  ? ; Ptr to CHSM type TCB free chain
    	ShimTCBList               dd  ? ; Ptr to CHSM type TCB list

	DriverAESPtr		  dd  ? ; Pointers to CHSM functions
	DriverINTPtr              dd  ?
	DriverISRPtr		  dd  ?
	DriverMulticastChangePtr  dd  ?
	DriverPollPtr		  dd  ?
	DriverResetPtr		  dd  ?
	DriverSendPtr		  dd  ?
	DriverShutdownPtr	  dd  ?
	spare2                    dd  ?
	DriverPromiscuousChangePtr dd ?
	DriverStatisticsChangePtr  dd ?
	DriverRxLookAheadChangePtr dd ?
	DriverManagementPtr	   dd ?
	DriverEnableInterruptPtr   dd ?
	DriverDisableInterruptPtr  dd ?
	DriverISR2Ptr             dd ?
	spare3                    dd ?
	spare4                    dd ?
	DriverPriorityQueuePtr    dd ?
	DriverDisableInterrupt2Ptr dd ?

	CopyStatisticsPtr         dd  ?   ; Pointer to stat cts cpy f

;;JRT 961127	ShortName		  db  10 dup( ? )
	ShortName		  db  16 dup( ? )       ;;JRT 961127
	ControlCompleteFlag	  db  8  dup( ? )
	ControlCompleteStatus	  dd  8  dup( ? )

;;JRT 961127 begin - statistics counters moved to end of structure
;;    	; Shim's Statistics Counters
;;	ShimStatTable		  db  SIZE MLIDStatStructure dup(?)
;;	StatTablePad              db  STAT_TABLE_PAD_SIZE dup(?)
;;JRT 961127 end

	;  Driver Parameter Block
	ShimDriverParmBlock	  db  SIZE DriverBlockStructure dup(?)

	;  Driver Configuration Template
	ShimConfigTable		  db  SIZE MLIDConfigurationStructure dup(?)

;;JRT 961127 begin
        ; Shim's Statistics Counters
        ShimStatTable             db  SIZE MLIDStatStructure dup(?)
;;JRT 961127 end

ShimAdapterDataSpace              ends

ShimAdapterDataSize		  equ	SIZE ShimAdapterDataSpace

;
;***************************************************************\
;                                                               *
; Negative Offset from HSM's AdapterDataSpace ptr to MSM data   *
; structure VirtualBoardLink array and DefaultVirtualBoard.     *
;                                                               *
;***************************************************************/
;
MSMVirtualBoardLink	equ	0 - (6 * 4)
MSMDefaultVirtualBoard	equ	0 - (10 * 4)

;***************************************************************\
;                                                               *
; CMSM_CONFIG_TABLE in assem form for use in CMSMGetConfigInfo  *
;                                                               *
;***************************************************************/

CMSM_TABLE_MAJOR_VERSION     equ     1
CMSM_TABLE_MINOR_VERSION     equ     0

ODI_CSPEC_MAJOR_VERSION      equ     1
ODI_CSPEC_MINOR_VERSION      equ     20

CMSM_CFG_SERVER_BIT	         equ     40000000h

CMSM_CONFIG_TABLE       struc

	CMSMCFG_TableSize             dd      size CMSM_CONFIG_TABLE
	CMSMCFG_TableMajorVersion     db      CMSM_TABLE_MAJOR_VERSION
	CMSMCFG_TableMinorVersion     db      CMSM_TABLE_MINOR_VERSION
	CMSMCFG_ModuleMajorVersion    db      ?
    CMSMCFG_ModuleMinorVersion    db      ?
    CMSMCFG_ODISpecMajorVersion   db      ODI_CSPEC_MAJOR_VERSION
    CMSMCFG_ODISpecMinorVersion   db      ODI_CSPEC_MINOR_VERSION
	CMSMCFG_Reserved              dw      ?
    CMSMCFG_MaxNumberOfBoards     dd      ?
	CMSMCFG_SystemFlags           dd      CMSM_CFG_SERVER_BIT

CMSM_CONFIG_TABLE       ends

;***************************************************************\
;                                                               *
; Auxiliary Data Block Structures in assem form                 *
;                                                               *
;***************************************************************/

AUX_DATA_BLOCK_HDR_VERSION  equ     1

AUX_DATA_BLOCK_HDR       struc

    auxType             dd          ?
    auxVersion          dd          AUX_DATA_BLOCK_HDR_VERSION
    auxLength           dd          ?
	auxPayloadVersion   dd          ?

AUX_DATA_BLOCK_HDR       ends

AUX_DATA_START           struc

    auxStartBlkHdr      dd          (size AUX_DATA_BLOCK_HDR / 4) dup (?)
    auxDataPhysAddr     dd          ?
	auxDataSize         dd          ?

AUX_DATA_START           ends

AUX_DATA_END            struc

    auxEndBlkHdr        dd          (size AUX_DATA_BLOCK_HDR / 4) dup (?)
    auxTerminator       dd          0

AUX_DATA_END            ends

