############################################################################
#	MSM.MAK is used to control the building of the Assembly MSM and MSM31X
#
#  Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
#
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION 
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
#
############################################################################
$(UTIL) : $(ENUMSGDIR)\$(MSGUTILNAME).msg $(CHSMSGDIR)\$(MSGUTILNAME).msg \
			$(FRAMSGDIR)\$(MSGUTILNAME).msg $(DEUMSGDIR)\$(MSGUTILNAME).msg \
			$(ITAMSGDIR)\$(MSGUTILNAME).msg $(JPNMSGDIR)\$(MSGUTILNAME).msg \
			$(KORMSGDIR)\$(MSGUTILNAME).msg $(PTBMSGDIR)\$(MSGUTILNAME).msg \
			$(RUSMSGDIR)\$(MSGUTILNAME).msg $(ESNMSGDIR)\$(MSGUTILNAME).msg \
			$(CHTMSGDIR)\$(MSGUTILNAME).msg $(EXEDIR)\$(UTIL).$(UTILEXT) \
			$(DBGEXEDIR)\$(UTIL).$(UTILEXT)


$(EXEDIR)\$(UTIL).$(UTILEXT): $[f,$(OBJDIR),$(OBJS),obj] \
								$(ENUMSGDIR)\$(MSGUTILNAME).msg \
								$(SRCDIR)\MSM.mak \
								$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DESCRIPTION)
	
	%Do Link

$(DBGEXEDIR)\$(UTIL).$(UTILEXT): $[f,$(DBGOBJDIR),$(OBJS),obj] \
									$(ENUMSGDIR)\$(MSGUTILNAME).msg \
									$(SRCDIR)\MSM.mak \
									$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DBGDESCRIPTION)
	%Set LINKDEBUG = $(DEBUGSTRING)

	%Do Link

Link:
	$(ASMLINKER)\checkerr
	%If $(UTIL) == MSM
		%Echo
		%Echo ------------------------------------------------------------------
		%Echo Building $[f,$[p,$[m,*.obj,$**]],$<,xdc]
		$(ASMLINKER)\mpkxdc -b $[f,$[p,$[m,*.obj,$**]],$<,xdc]
	%End
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Linking $@
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do DeleteFile
	%endfor
	$(COMPILE)\wlink <@<
format Novell $(UTILEXT) '$(DESCRIP)'
$(LINKDEBUG)
name $@
file $[s,",",$[m,$[p,$[m,*.obj,$**]]*.obj,$**]]
option copyright $(COPYRIGHT_TXT)
option version = $(MAJOR_VER).$(MINOR_VER).$(REV)
option messages = $(ENUMSGDIR)\$(MSGUTILNAME).msg
option start = MSMInitializeDriver
option exit  = MSMRemoveDriver
option map = $[f,$[d,$@],$@,map]
option quiet
option verbose
option nodefaultlibs
option namelen = 30
%If $(UTIL) == MSM
option XDCData = $[f,$[p,$[m,*.obj,$**]],$<,xdc]
%end
%If %Defined(SYM)
option SYMFILE = $[f,$[d,$@],$@,sym]
%EndIf

%If $(UTIL) == MSM31X
module	NBI|NBI31X,AFTER311
%Else
module	NBI
%End

import	ScanCardInfo,
%If $(UTIL) == MSM31X
        WriteFile,
        GetHighResolutionTimer,
        AllocBufferBelow16Meg,
        AllocNonMovableCacheMemory,
        CRescheduleLast,
        ClearHardwareInterrupt,
	DisableHardwareInterrupt,
	EnableHardwareInterrupt,
        FileServerMajorVersionNumber,
        FileServerMinorVersionNumber,
        FreeBufferBelow16Meg,
        FreeNonMovableCacheMemory,
        QueueSystemAlert,
        LoadedList,
        SetHardwareInterrupt,
        ExternalPublicList,
        InternalPublicList,
%Else
	AllocateMappedPages,
	CYieldWithDelay,
        DeAllocateMappedPages,
        GetFileServerMajorVersionNumber,
        GetFileServerMinorVersionNumber,
        GetNLMNames,
        GetNLMVersionInfo,
        GetServerPhysicalOffset,
        GetSuperHighResolutionTimer,
        ImportPublicSymbol,
        NetWareAlert,
        ReadEISAConfig,
        ReadPhysicalMemory,
        WritePhysicalMemory,
        LSLControlStackFilter,
        GetNumberOfLANs,
%End
	ActivateScreen,
        AddPollingProcedureRTag,
        Alloc,
        AllocateResourceTag,
        CancelInterruptTimeCallBack,
        CancelNoSleepAESProcessEvent,
        CancelSleepAESProcessEvent,
        CFindResourceTag,
        CloseFile,
        ConvertStringToUnsignedLong,
	CStrCmp,
	CStrLen,
        DeRegisterHardwareOptions,
        DisableInputCursor,
        DoEndOfInterrupt,

	Enable,
        EnableInputCursor,
        Free,

	GetBusName,
	GetBusSpecificInfo,
	GetBusTag,
	GetBusType,
	GetBusInfo,

	WrtConfigSpace8,
	WrtConfigSpace16,
	WrtConfigSpace32,
	RdConfigSpace8,
	RdConfigSpace16,
	RdConfigSpace32,
	GetCardConfigInfo,
	SearchAdapter,

        GetCurrentTime,
        GetNestedInterruptLevel,
        GetSystemMemoryMap,
	GetSystemConsoleScreen,

        InputFromKeyboard,
        INWDOSClose,

        KillMe,

        LSLAddProtocolID,
        LSLDeRegisterMLID,
        LSLFastRcvEvent,
        LSLGetMaximumPacketSize,
        LSLGetSizedRcvECBRTag,
        LSLHoldRcvEvent,
        LSLRegisterMLIDRTag,
        LSLReturnRcvECB,
        LSLUnBindThenDeRegisterMLID,

        MapAbsoluteAddressToDataOffset,
        MapDataOffsetToAbsoluteAddress,
        MLIDConfigurationTable,

        NBIRequest,
        NumberOfLANs,

        OpenFileUsingSearchPath,
        OutputToScreen,

        RegisterConsoleCommand,
	RegisterDebugCommandParser,
        ParseDriverParameters,
        RegisterForEventNotification,
        RegisterHardwareOptions,
        RemovePollingProcedure,
        RingTheBell,

	ScanBusInfo,
        ScheduleInterruptTimeCallBack,
        ScheduleNoSleepAESProcessEvent,
        ScheduleSleepAESProcessEvent,
        SetInputToOutputCursorPosition,
        UnRegisterConsoleCommand,
	UnRegisterDebugCommandParser,
        UnRegisterEventNotification,
        UnloadModule,

        DoRealModeInterrupt,
	GetRealModeWorkSpace,
	CPSemaphore,
	CVSemaphore,

	CMovB,
	CSetB,
	ReturnMessageInformation,
	IOConfigurationList,
	GetInstanceNumber,
	GetInstanceNumberMapping,
	GetNBIConfiguration,
	GetUniqueIdentifierParameters,
	LSLServiceEvents

export 
# following are temporaries !!
#	MSMTrace,
#	MSMTraceTable,
        
        MSMMPKActvFlag,
        LogicalToPhysical,

        MSMAESProcedure,
        MSMAlertFatal,
        MSMAlertWarning,
        MSMAlloc,
	MSMAllocateMultipleRCBs,
        MSMAllocPages,
        MSMAllocateRCB,
        MSMASCIIToDWord,

        MSMBitSwapTable,

        MSMCallBackProcedure,
	MSMCancelTimer,
        MSMCanonicalMode,
        MSMControlStackFilter,

        MSMDeRegisterODINEB,
	MSMDeRegisterResource,
        MSMDeRegisterSharedMemory,
	MSMDisableWriteCombine,
        MSMDriverControlCall,
        MSMDriverControlShim,
        MSMDriverRemove,
        MSMDriverSendCall,

        MSMEnablePolling,
	MSMEnableWriteCombine,
        MSMEnqueueSend,

        MSMFastRcvEvent,
        MSMFastRcvEventBelow16,
        MSMFileServerMajorVersionNumber,
        MSMFileServerMinorVersionNumber,
        MSMFree,
        MSMFreePages,

        MSMGetAlignment,
        MSMGetConfigInfo,
	MSMGetBoardDiagnosticInfo,
	MSMGetBoardInterruptTags,
        MSMGetBusInfo,
        MSMGetBusName,
        MSMGetBusSpecificInfo,
        MSMGetBusTag,
        MSMGetBusType,
        MSMGetConfigFromLogicalBoardNumber,
        MSMGetConfigFromLogicalBoardName,
        MSMGetConfigFromAdapterName,
        MSMGetConfigFromHIN,
        MSMGetCardConfigInfo,
        MSMGetHINFromHINName,
        MSMGetHINNameFromHIN,
	MSMGetInstanceNumber,
	MSMGetInstanceNumberMapping,
        MSMGetLogical,
        MSMGetMicroTimer,
        MSMGetPhysical,
        MSMGetPhysicalAddressOfECB,
        MSMGetPhysList,
	MSMGetPollSupportLevel,
        MSMGetTSMIFLevel,
	MSMGetUniqueIdentifier,
	MSMGetUniqueIdentifierParameters,
        MSMGetVersionNumber,

        MSMHardwareFailure,
        MSMHoldRcvEvent,
        MSMHoldRcvEventBelow16,

        MSMInitAlloc,
        MSMInitFree,
        MSMInterruptProcedureCall,
        MSMInterrupt2ProcedureCall,
        MSMIOCTLJumpTable,

        MSMModuleHandle,

        MSMNESLDeRegisterConsumer,
        MSMNESLDeRegisterProducer,
        MSMNESLProduceEvent,
        MSMNESLProduceMLIDEvent,
        MSMNESLRegisterConsumer,
        MSMNESLRegisterProducer,

        MSMParseCustomKeywords,
        MSMParseDriverParameters,
        MSMPhysicalEqualsLogical,
        MSMPhysicalPageSize,
        MSMPrintString,
        MSMPrintStringFatal,
        MSMPrintStringWarning,

	MSMRdConfigSpace8,
	MSMRdConfigSpace16,
	MSMRdConfigSpace32,
        MSMReadEISAConfig,
        MSMReadPhysicalMemory,
        MSMRegisterHardwareOptions,
        MSMRegisterMLID,
        MSMRegisterODINEB,
        MSMRegisterSharedMemory,
        MSMRegisterResource,
        MSMRegisterTSM,
	MSMReRegisterHardwareOptions,
        MSMResetMLID,
	MSMResumePolling,
        MSMReturnDriverResources,
	MSMReturnMultipleRCBs,
        MSMReturnRcvECB,
        
        MSMScanBusInfo,	
        MSMScheduleAESCallBack,
        MSMScheduleIntTimeCallBack,
	MSMScheduleTimer,
        MSMSearchAdapter,
        MSMSetHardwareInterrupt,
        MSMShutdownMLID,
	MSMSMPActvFlag,
	MSMSuspendPolling,

	MSMUpdateConfigTables,

        MSMWritePhysicalMemory,
	MSMWrtConfigSpace8,
	MSMWrtConfigSpace16,
	MSMWrtConfigSpace32,

	MSMGetMaxFragCount,
	MSMCombineFrags,

        MSMYieldWithDelay,

        PhysicalToLogical,

	CMSMAddToCounter,
	CMSMAlloc,
	CMSMAllocateMultipleRCBs,
	CMSMAllocPages,
	CMSMAllocateRCB,

	CMSMCancelAES,
	CMSMControlComplete,

	CMSMDeRegisterResource,
	CMSMDisableHardwareInterrupt,
	CMSMDisableWriteCombine,
	CMSMDriverRemove,

	CMSMECBPhysToLogFrags,
	CMSMEnablePolling,
	CMSMEnableHardwareInterrupt,
	CMSMEnableWriteCombine,

	CMSMFree,
	CMSMFreePages,

	CMSMGetAlignment,
	CMSMGetBoardDiagnosticInfo,
	CMSMGetBoardInterruptTags,
	CMSMGetBusInfo,
	CMSMGetBusName,
        CMSMGetBusSpecificInfo,
	CMSMGetBusTag,
	CMSMGetBusType,
	CMSMGetCardConfigInfo,
	CMSMGetConfigInfo,
	CMSMGetCurrentTime,
        CMSMGetHINFromHINName,
        CMSMGetHINNameFromHIN,
        CMSMGetInstanceNumber,
        CMSMGetInstanceNumberMapping,
	CMSMGetMicroTimer,
        CMSMGetNBIConfiguration,
	CMSMGetPhysical,
        CMSMGetPhysList,
        CMSMGetPollSupportLevel,
	CMSMGetSlot,
	CMSMGetSlotName,
	CMSMGetUniqueIdentifier,
        CMSMGetUniqueIdentifierParameters,

        CMSMHardwareFailure,

	CMSMIncrCounter,
	CMSMInitAlloc,
	CMSMInitParser,

        CMSMNESLDeRegisterConsumer,
        CMSMNESLDeRegisterProducer,
        CMSMNESLProduceEvent,
        CMSMNESLProduceMLIDEvent,
        CMSMNESLRegisterConsumer,
        CMSMNESLRegisterProducer,

	CMSMParseDriverParameters,
	CMSMParseSingleParameter,
	CMSMPrintString,

	CMSMRdConfigSpace8,
	CMSMRdConfigSpace16,
	CMSMRdConfigSpace32,
	CMSMReadPhysicalMemory,
	CMSMRegisterHardwareOptions,
	CMSMRegisterMLID,
	CMSMRegisterResource,
	CMSMReRegisterHardwareOptions,
        CMSMResetMLID,
	CMSMResumePolling,
	CMSMReturnDriverResources,
	CMSMReturnMultipleRCBs,
	CMSMReturnRCB,

	CMSMScanBusInfo,
	CMSMScheduleAES,
	CMSMSearchAdapter,
	CMSMServiceEvents,
	CMSMSetHardwareInterrupt,
        CMSMShutdownMLID,
	CMSMSuspendPolling,

        CMSMTCBPhysToLogFrags,

	CMSMUpdateConfigTables,

	CMSMWrtConfigSpace8,
	CMSMWrtConfigSpace16,
	CMSMWrtConfigSpace32,
	CMSMWritePhysicalMemory,

	CMSMYieldWithDelay,

    CMSMInitializeAuxDataBuffer,
    CMSMInsertBlockIntoAuxDataBuffer,
    CMSMRemoveBlockFromAuxDataBuffer,
    CMSMFindBlockInAuxDataBuffer,
    CMSMCompressAuxDataBuffer,
    CMSMExpandAuxDataBuffer,
    CMSMValidateAuxDataBuffer,

	FreeBusMemory,
	MapBusMemory,

        CACSAdapterTempPtr,
        CACSAlloc,
        CACSCHSMAdapterDataSize,
        CACSDriverRegistered,
        CACSDriverTable,
        CACSFree,
        CACSFindMessages,
        CACSNumberFrames,
        CACSPrintError,
#       CACSRemoveCTSM,
        CACSGetNumberCustomCounters,

      # Global variables
		NESL_Service_Suspend,
		NESL_Service_Resume,
		NESL_ServiceStatus_Change,
		NESL_Suspend_Request,
		NESL_MLID_ShutDown,
		NESL_MLID_Card_Removal,
		NESL_MLID_Out_Range,
		NESL_MLID_HW_Failure,
		NESL_MLID_Cable_Disconnect,
		NESL_MLID_Media_Access_Denied,
		NESL_MLID_Reset,
		NESL_MLID_Card_Insertion_Complete,
		NESL_MLID_In_Range,
		NESL_MLID_Cable_Reconnect,
		NESL_MLID_Access_Point_Change,
		NESL_MLID_Speed_Change,
		NESL_MLID_Config_Table_Change,
		NESL_MLID_DeRegister_Resource_Change,
		NESL_MLID_ReRegister_Hardware_Options_Change
<
	%Echo $(BEGINGREEN) Finished Building -- $(DESCRIP) in Directory $@ $(ENDANSI)

	%If %Defined(ENGTEST)
		%Echo ***************************************************************
		%Echo $(BEGINYELLOW) $(WARNINGENG) $(ENDANSI)
		%Echo ***************************************************************
	%EndIf
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do	AttributeAdd
	%endfor