############################################################################
#	CFDDITSM.MAK controls the building of the FDDITSM.NLM ODI TSM (C)
#		for Client-32, NT & NWServer platforms.
#
#   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
# 
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION 
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
# 
############################################################################

$(UTIL) : $(ENUMSGDIR)\$(MSGUTILNAME).msg $(CHSMSGDIR)\$(MSGUTILNAME).msg \
			$(FRAMSGDIR)\$(MSGUTILNAME).msg $(DEUMSGDIR)\$(MSGUTILNAME).msg \
			$(ITAMSGDIR)\$(MSGUTILNAME).msg $(JPNMSGDIR)\$(MSGUTILNAME).msg \
			$(KORMSGDIR)\$(MSGUTILNAME).msg $(PTBMSGDIR)\$(MSGUTILNAME).msg \
			$(RUSMSGDIR)\$(MSGUTILNAME).msg $(ESNMSGDIR)\$(MSGUTILNAME).msg \
			$(CHTMSGDIR)\$(MSGUTILNAME).msg $(EXEDIR)\$(UTIL).$(UTILEXT) \
			$(DBGEXEDIR)\$(UTIL).$(UTILEXT)

$(EXEDIR)\$(UTIL).$(UTILEXT): $[f,$(OBJDIR),$(OBJS),obj] \
								$(ENUMSGDIR)\$(MSGUTILNAME).msg \
								$(SRCDIR)\cfdditsm.mak $(SRCDIR)\specific.bat
	%Set DESCRIP = $(DESCRIPTION)

	%Do Link

$(DBGEXEDIR)\$(UTIL).$(UTILEXT): $[f,$(DBGOBJDIR),$(OBJS),obj] \
									$(ENUMSGDIR)\$(MSGUTILNAME).msg \
									$(SRCDIR)\cfdditsm.mak $(SRCDIR)\specific.bat
	%Set LINKDEBUG = $(DEBUGSTRING)
	%Set DESCRIP = $(DBGDESCRIPTION)
	%Set CMSMOutMEON = import	CMSMOutMEON
	%Set CMSMOutUINT16 = import	CMSMOutUINT16
	%Set CMSMOutUINT32 = import	CMSMOutUINT32
	%Set CMSMOutUINT8 = import	CMSMOutUINT8
	%Set EnterDebugger = import	EnterDebugger

	%Do Link

Link:
	$(ASMLINKER)\checkerr
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Linking $@
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do DeleteFile
	%endfor
	$(COMPILE)\wlink <@<
format Novell $(UTILEXT) '$(DESCRIP)'
$(LINKDEBUG)
name $@
file $[s,",",$[m,$[p,$[m,*.obj,$**]]*.obj,$**]]
option copyright $(COPYRIGHT_TXT)
option version = $(MAJOR_VER).$(MINOR_VER).$(REV)
option messages = $(ENUMSGDIR)\$(MSGUTILNAME).msg
option start = CInitializeFDDITSM
option exit = CRemoveFDDITSM
option map = $[f,$[d,$@],$@,map]
option caseexact
option quiet
option verbose
option nodefaultlibs
option namelen = 30
%If %Defined(SYM)
option SYMFILE = $[f,$[d,$@],$@,sym]
%EndIf

%If "$(OS)" != "\NT"
module	CMSM
%End

import	CLSL_ControlStackFilter,	# CLSL APIS imported
		CLSL_FastHoldEvent,
		CLSL_FastSendComplete,
		CLSL_GetStackECB,
		CLSL_HoldEvent,
		CLSL_SendComplete,
		
		CMSMAlloc,					# CMSM APIs Imported
		CMSMAllocateRCB,
		CMSMAcquireProtection,
		CMSMEnqueueSend,
		CMSMFree,
		CMSMGetPhysical,
		CMSMGetPhysicalECB,
		CMSMGetNLMVersionInfo,
		CMSMPrintString,
        CMSMParseCTSMParameters,
		CMSMRegisterTSM,
		CMSMReleaseProtection,
		CMSMReturnDriverResources,
		CMSMReturnRCB,
		CMSMReturnPhysicalECB,
        CMSMstrcspn,
        CMSMstrcmp,
        CMSMstrcpy,
        CMSMstrstr,
        CMSMstrlen,
        CMSMASCIINodeToHex,
		CurrentFrameData,
		CMSMBuildGenericStatStrings,

		MSMBitSwapTable,			# Global Variables

		ReturnMessageInformation	# OS APIs Imported

%If "$(OS)" == "\CLIENT32"
import	CLSL_ServiceEvents,			# CLSL APIS imported
		NiosMemCpy,  				# NIOS APIs Imported
		NiosMemSet,
		NiosMemCmp,
		GetNLMVersionInfo			# Global Variables
%ElseIf "$(OS)" == "\NWSERVER"
import	CLSL_ServiceEvents,			# CLSL APIS imported
		CMovB,						# OS APIs imported
		CSetB,
		NiosMemCpy,  				# NIOS APIs Imported
		NiosMemSet,
		NiosMemCmp,
		GetNLMVersionInfo			# Global Variables
%ElseIf	"$(OS)" == "\NT"
import	CMSMReturnMessageInformation
%End

# MSM APIs Imported in debug version only.						  				
$(CMSMOutMEON)
$(CMSMOutUINT16)
$(CMSMOutUINT32)
$(CMSMOutUINT8)

%If	"$(OS)" == "\NT"
$(EnterDebugger)
%EndIf

##############################################################

export	CFDDITSMBuildTransmitControlBlock,
		CFDDITSMCancelPrioritySend,
		CFDDITSMFastProcessGetRCB,
		CFDDITSMFastRcvComplete,
		CFDDITSMFastRcvCompleteStatus,
		CFDDITSMFastSendComplete,
		CFDDITSMGetConfigInfo,
		CFDDITSMGetHSMIFLevel,
		CFDDITSMGetRCB,
		CFDDITSMProcessGetRCB,
		CFDDITSMRcvComplete,
		CFDDITSMRcvCompleteStatus,
		CFDDITSMRegisterHSM,
		CFDDITSMSendComplete,
		
		FDDITSMBuildTransmitControlBlock,
		FDDITSMCancelPrioritySend,
		FDDITSMGetConfigInfo,
		FDDITSMGetNextSend,
		FDDITSMGetRCB,
		FDDITSMProcessGetRCB,
		FDDITSMFastProcessGetRCB,
		FDDITSMRcvComplete,
		FDDITSMRcvCompleteStatus,
		FDDITSMFastRcvComplete,
		FDDITSMFastRcvCompleteStatus,
		FDDITSMRegisterHSM,
		FDDITSMSendComplete,
		FDDITSMFastSendComplete,
		FDDITSMUpdateMulticast,
		FDDITSMGetASMHSMIFLevel

%If "$(OS)" == "\CLIENT32"
export	CFDDITSMUpdateMulticast,
		FDDITSMGetConfigInfo		
%ElseIf "$(OS)" == "\NWSERVER"
export	CFDDITSMGetNextSend,
		FDDITSMGetConfigInfo
%ElseIf	"$(OS)" == "\NT"
export	CFDDITSMUpdateMulticast

%End

<
	%Echo $(BEGINGREEN) Finished Building -- $(DESCRIP) in Directory $@ $(ENDANSI)

	%If %Defined(ENGTEST)
		%Echo ***************************************************************
		%Echo $(BEGINYELLOW) $(WARNINGENG) $(ENDANSI)
		%Echo ***************************************************************
	%EndIf
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do	AttributeAdd
	%endfor 


