/***********************************************************************\
*
*   (c) Unpublished Work of Novell, Inc.  All rights reserved.
*
*   THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
*   PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS
*   TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
*   NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS
*   AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO
*   APPROPRIATE LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED,
*   PRACTICED, PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED,
*   TRANSLATED, ABRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED,
*   LINKED,RECAST, TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN
*   CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT
*   THE PRIOR WRITTEN CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF
*   THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
*   CRIMINAL AND CIVIL LIABILITY.
*
***********************************************************************
*
*  Name:			CMSM String Header Module
*
*  FileName:		CMSMSTR.H
*
*  ODI Spec Ver:	1.11
*
*  Description:   	Special function library for Novell ODI CHSM
*                 	parameter parser.
*
*  Modification History:
*
*  ??-??-?? ???		? (this is the format, please replace with first entry)
*
\***********************************************************************/

#include <odi.h>
#include <stdarg.h>

#ifndef __LIMITS_H__
#define __LIMITS_H__

#define CHAR_BIT		8					/* max # of bits in a "char" */
#define SCHAR_MIN		(-128)			/* min value of a "signed char" */
#define SCHAR_MAX		127				/* max value of a "signed char" */
#define UCHAR_MAX		255				/* max value of an "unsigned char" */

#ifdef __CHAR_SIGNED__
# define CHAR_MIN		SCHAR_MIN		/* min value of a "char" */
# define CHAR_MAX		SCHAR_MAX		/* max value of a "char" */
#else
# define CHAR_MIN	0
# define CHAR_MAX		UCHAR_MAX
#endif

#define MB_LEN_MAX	5					/* max # bytes in multibyte character */

#define SHRT_MIN		(-32768)			/* min value of a "short int" */
#define SHRT_MAX		32767				/* max value of a "short int" */
#define USHRT_MAX		65535				/* max value of an "unsigned short int" */
#define LONG_MIN		(-2147483647-1)/* min value of a "long int" */
#define LONG_MAX		2147483647		/* max value of a "long int" */
#define ULONG_MAX		4294967295	 	/* max value of an "unsigned long int" */
#define INT_MIN		LONG_MIN			/* min value of an "int" */
#define INT_MAX		LONG_MAX			/* max value of an "int" */
#define UINT_MAX		ULONG_MAX		/* max value of an "unsigned int" */

#ifndef TZNAME_MAX
# define TZNAME_MAX	8					/* max characters for time zone name */
#endif

#endif

/*=========================================================================*/

#ifndef __CTYPE_H__
#define __CTYPE_H__

#ifdef __cplusplus
extern "C"
{
#endif

#ifndef Uint
#define Uint unsigned int
#endif

#ifndef Ulong
#define Ulong unsigned long
#endif

#ifndef Ushort
#define Ushort unsigned short
#endif

#ifndef Uchar
#define Uchar unsigned char
#endif

extern unsigned char	__ctype[];

int	_cdecl   CMSMisalnum(int);
int	_cdecl   CMSMisalpha(int);
int	_cdecl   CMSMiscntrl(int);
int	_cdecl   CMSMisdigit(int);
int	_cdecl   CMSMisgraph(int);
int	_cdecl   CMSMislower(int);
int	_cdecl   CMSMisprint(int);
int	_cdecl   CMSMispunct(int);
int	_cdecl   CMSMisspace(int);
int	_cdecl   CMSMisupper(int);
int	_cdecl   CMSMisxdigit(int);
int	_cdecl   CMSMtolower(int);
int	_cdecl   CMSMtoupper(int);

#ifdef __cplusplus
}
#endif

#ifndef _UPPER_
# define _UPPER_	01		/* Upper case */
# define _LOWER_	02		/* Lower case */
# define _DIGIT_	04		/* Numeral (digit) */
# define _SPACE_	010	/* Spacing character */
# define _PUNCT_	020	/* Punctuation */
# define _CNTRL_	040	/* Control character */
# define _BLANK_	0100	/* Blank */
# define _XDIGIT_	0200	/* heXadecimal digit */
#endif

#endif


/*=========================================================================*/

#ifndef __STRING_H__
#define __STRING_H__

#ifndef NULL
# define NULL	0
#endif

#ifndef _SIZE_T
# define _SIZE_T
typedef unsigned int	size_t;
#endif

#ifdef __cplusplus
extern "C"
{
#endif


int		_cdecl   CMSMatoi(const MEON_STRING	*);

MEON_STRING		* _cdecl   CMSMstrcpy(MEON_STRING *, const MEON_STRING *);
MEON_STRING		* _cdecl   CMSMstrncpy(MEON_STRING *, const MEON_STRING *, size_t);

MEON_STRING		* _cdecl   CMSMstrcat(MEON_STRING *, const MEON_STRING *);

MEON_STRING		*_cdecl   CMSMstrchr(const MEON_STRING *, int);
size_t	_cdecl   CMSMstrcspn(const MEON_STRING *, const MEON_STRING *);
MEON_STRING		* _cdecl   CMSMstrpbrk(const MEON_STRING *, const MEON_STRING *);
MEON_STRING		* _cdecl   CMSMstrrchr(const MEON_STRING *, int);
size_t	_cdecl   CMSMstrspn(const MEON_STRING *, const MEON_STRING *);
MEON_STRING		* _cdecl   CMSMstrstr(const MEON_STRING *, const MEON_STRING *);

int		_cdecl   CMSMstrcmp(const MEON_STRING	*s1, const MEON_STRING	*s2);
size_t	_cdecl   CMSMstrlen(const MEON_STRING *);

int		_cdecl   CMSMsscanf(	const MEON_STRING	*, const MEON_STRING	*, ...);

/* non-ANSI string functions... */
int      _cdecl   CMSMatox(register const MEON_STRING *);
void     _cdecl   CMSMitoa(MEON_STRING *s, int n);
void     _cdecl   CMSMxtoa(MEON_STRING *s, unsigned int n);

MEON_STRING		* _cdecl   CMSMstrlwr(MEON_STRING *);
MEON_STRING		* _cdecl   CMSMstrupr(MEON_STRING *);

#ifdef __cplusplus
}
#endif

#endif

/*=========================================================================*/

#ifndef __misc_h__
#define __misc_h__

#ifndef NULL
# define NULL	0
#endif

#ifndef TRUE
# define TRUE	1
# define FALSE	0
#endif

#ifndef EOF
# define EOF	(-1)
#endif

#ifndef inrange
# define inrange(l,x,h)	( (x) >= (l) && (x) <= (h) )
#endif

#ifndef min
# define min(a, b)			(((a) < (b)) ? (a) : (b))
#endif

#ifndef max
# define max(a, b)			(((a) > (b)) ? (a) : (b))
#endif

typedef union				/* random access va_list object */
{
	va_list	ap;
	Uchar		flag;
} RA_va_list;

extern void	_cdecl   _parglist(const char *, RA_va_list *, int, int, int);

#if defined(IAPX386) && !defined(DEBUG)
#ifdef __INLINE_FUNCTIONS__
/*
** The following macros will cause the Watcom compiler to generate in-line
** code for a few high-use, critical functions. These functions are still
** available as imports to client NLMs. In debug mode, this isn't done so
** that a) testing of these functions may be done and b) debugging is made
** a bit easier by the names showing up in the code.
*/

int		_inline_memcmp( const void *, const void *, size_t );
int		_inline_strcmp( const char *, const char * );
size_t	_inline_strlen( const char * );
void		*_inline_memchr( const void *, int, size_t );
void		*_inline_memcpy( void *, const void *, size_t );
void		*_inline_memset( void *, int, size_t );
char		*_inline_strcat( char *, const char * );
char		*_inline_strcpy( char *, const char * );
char		*_inline_strchr( const char *, int );

#  define memchr(p,c,n)     _inline_memchr(p,c,n)
#  define memcmp(p1,p2,n)   _inline_memcmp(p1,p2,n)
#  define memcpy(p1,p2,n)   _inline_memcpy(p1,p2,n)
#  define memset(p,c,n)     _inline_memset(p,c,n)
#  define strcat(p1,p2)     _inline_strcat(p1,p2)
#  define strcmp(p1,p2)     _inline_strcmp(p1,p2)
#  define strcpy(p1,p2)     _inline_strcpy(p1,p2)
#  define strlen(p1)        _inline_strlen(p1)
#  define strchr(p1,p2)     _inline_strchr(p1,p2)

#endif
#endif

#endif

/*=========================================================================*/
/*=========================================================================*/
