/***********************************************************************\
*
*   (c) Unpublished Work of Novell, Inc.  All rights reserved.
*
*   THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
*   PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS
*   TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
*   NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS
*   AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO
*   APPROPRIATE LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED,
*   PRACTICED, PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED,
*   TRANSLATED, ABRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED,
*   LINKED,RECAST, TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN
*   CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT
*   THE PRIOR WRITTEN CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF
*   THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
*   CRIMINAL AND CIVIL LIABILITY.
*
***********************************************************************
*
*  Name:			NBI Definitions
*
*  FileName:	  	ODI_NBI.H
*
*  ODI Spec Ver:   	1.11
*
*  Description:   	C version of the NBI
*
*  Modification History:
*
*  01-29-97 WTT		Added structure definition for PCI_CONFIG_SPACE.
*
*  02-17-97 WTT		Added structure definition for ODI_NBI_HIN_NAME_INFO.
*					Also added defines for NBIVERB_MAP_HIN_TO_HINNAME,
*					NBIVERB_MAP_HINNAME_TO_HIN, and MAX_HIN_NAME_SIZE.
*
*  02-20-97 WTT		Added define for ODI_BUSTYPE_CARDBUS.
*
*  04-02-97 KRA		In the MapBusMemory prototype change void *mappedAddr
*							to be void **mappedAddr to match the spec.
*
*  10-17-98 mcd     Modified the structure PCI_Cfg_Space to match what the
*                   NBI is returning.
*
\***********************************************************************/

#ifndef _ODI_NBI_MOD_
#define _ODI_NBI_MOD_

#ifndef OS_NT
#ifndef OS_WIN95
#ifndef _cdecl
#define	_cdecl		
#endif
#endif
#endif

typedef enum _ODI_NBI_{
		ODI_NBI_SUCCESSFUL =				0,
		ODI_NBI_PROTECTION_VIOLATION =		1,
		ODI_NBI_HARDWARE_ERROR =			2,
		ODI_NBI_MEMORY_ERROR =				3,
		ODI_NBI_PARAMETER_ERROR =			4,
		ODI_NBI_UNSUPPORTED_OPERATION =		5,
		ODI_NBI_ITEM_NOT_PRESENT =			6,
		ODI_NBI_NO_MORE_ITEMS =          	7,
		ODI_NBI_FAIL =                   	8,
		ODI_NBI_BUS_SPECIFIC_ERROR =		9,
		ODI_NBI_PARENT_INSTANCE_NONEXIST =	-1,
		ODI_NBI_NO_INSTANCE_AVAIL =		 	-2,
		ODI_NBI_INSTANCE_NONEXIST =	 		-3,
		ODI_NBI_NO_MEM =					-4,
		ODI_NBI_INTERNAL_ERR = 				-5,
		ODI_NBI_NEWINSTANCE_EXIST =			-6,
		ODI_NBI_SAME_AS_NO_MORE_ITEMS =		-7,
		ODI_NBI_INVALID_FUNCTION =			-8,
		ODI_NBI_SAME_AS_PARAMETER_ERROR =	-9,
		ODI_NBI_NO_SLOTIDNAME_AVAIL =		-10,
		ODI_NBI_NO_INSTANCENAME_AVAIL =		-11,
		ODI_NBI_INSTANCE_NOT_SAVED =		-12
		} ODI_NBI;

#define ODI_BUSTYPE_ISA      0
#define ODI_BUSTYPE_MCA      1
#define ODI_BUSTYPE_EISA     2
#define ODI_BUSTYPE_PCMCIA   3
#define ODI_BUSTYPE_PCI      4
#define ODI_BUSTYPE_VESA     5
#define ODI_BUSTYPE_NUBUS    6
#define ODI_BUSTYPE_OFM      7
#define ODI_BUSTYPE_CARDBUS	 8


/* The following bits are defined for CMSMGetCardConfigInfo - PC Card and CardBus */

#define ODI_DEFAULT_INFO	 	0
#define ODI_IO_MEMORY_WINDOWS	1


#define CMAX_MEM_REGS        9
#define CMAX_IO_PORTS        20
#define CMAX_IRQS            7
#define CMAX_DMAS            7
#define CMAX_VDS             256

typedef struct PCI_Cfg_Space
{
	UINT16	vendorID;
	UINT16	deviceID;
	UINT16	commandReg;
	UINT16	statusReg;
	UINT8	revisionID;
	UINT8	classCode[3];
	UINT8	cacheLineSize;
	UINT8	latencyTimer;
	UINT8	headerType;
	UINT8	bist;
	UINT32	baseAddress[6];
	UINT32	cardbusCISPointer;
	UINT16	subsystemVendorID;
	UINT16	subsystemID;
	UINT32	expansionRomBaseAddress;
	UINT32	headerReserved1;
	UINT32	headerReserved2;
	UINT8	interruptLine;
	UINT8	interruptPin;
	UINT8	minGrant;
	UINT8	maxLatency;
	UINT32	optional[48];
} PCI_CONFIG_SPACE;

/**********************************************************************\
*                                                                      *
* NBI Specific declarations.															*
*                                                                      *
***********************************************************************/

/**********************************************************************\
*                                                                      *
* DMACleanup																				*
*                                                                      *
***********************************************************************/

void	_cdecl DMACleanup(
				UINT32					DMAChannel);

/**********************************************************************\
*                                                                      *
* DMAStart																					*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl DMAStart(
				void					  *destBusTag,
				UINT32					destAddrType,
				const void				*destAddr,
				void					  *srcBusTag,
				UINT32					srcAddrType,
				const void				*srcAddr,
				UINT32					len,
				UINT32					dmaChannel,
				UINT32					dmaMode1,
				UINT32					dmaMode2);	/* TNL 8/3/95 Add DMAMode2 */

/**********************************************************************\
*                                                                      *
* DMAStatus																				*
*                                                                      *
***********************************************************************/

UINT32	_cdecl DMAStatus(
				UINT32					dmaChannel);

/**********************************************************************\
*                                                                      *
* FreeBusMemory   			 															*
*                                                                      *
***********************************************************************/

ODI_NBI _cdecl FreeBusMemory(
			void			*busTag1,
			const void	*memAddr,
			void			*busTag2,
			const void	*mappedAddr,
			UINT32		len);


/**********************************************************************\
*                                                                      *
* In8																						*
*                                                                      *
***********************************************************************/

UINT8		_cdecl In8(
				void                 *busTag,
				const void				*ioAddr);

#ifdef _WATCOMC_
#pragma aux In8 parm [EAX] [EDX];

#pragma aux In8 = \
	0xec					/* in	al, dx */ \
	parm [EAX] [EDX] 						\
	modify exact [EAX EDX];

#endif

/**********************************************************************\
*                                                                      *
* In16 																						*
*                                                                      *
***********************************************************************/

UINT16	_cdecl In16(
				void                 *busTag,
				const void				*ioAddr);

#ifdef _WATCOMC_
#pragma aux In16 parm [EAX] [EDX];

#pragma aux In16 = \
	0x66	0xed			/* in	ax, dx */ \
	parm [EAX] [EDX] 						\
	modify exact [EAX EDX];

#endif

/**********************************************************************\
*                                                                      *
* In32																						*
*                                                                      *
***********************************************************************/

UINT32	_cdecl In32(
				void                 *busTag,
				const void				*ioAddr);

#ifdef _WATCOMC_
#pragma aux In32 parm [EAX] [EDX];

#pragma aux In32 = \
	0xed					/* in	eax, dx */ \
	parm [EAX] [EDX] 						\
	modify exact [EAX EDX];

#endif

/**********************************************************************\
*                                                                      *
* InBuff8																					*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl InBuff8(
				UINT8						*bufferPtr,
				void                 *busTag,
				const void				*ioAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux InBuff8 parm [EDI] [EAX] [EDX] [ECX];

#pragma	aux InBuff8 = \
	0xF3 0x6C                        	/* rep	insb							*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDI] [EAX] [EDX] [ECX] \
	modify exact [EAX ECX EDX EDI];

#endif

/**********************************************************************\
*                                                                      *
* InBuff16																					*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl InBuff16(
				UINT8						*bufferPtr,
				void                 *busTag,
				const void				*ioAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux InBuff16 parm [EDI] [EAX] [EDX] [ECX];

#pragma	aux InBuff16 = \
	0xF3 0x66 0x6D                      /* rep	insw							*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDI] [EAX] [EDX] [ECX] \
	modify exact [EAX ECX EDX EDI];

#endif

/**********************************************************************\
*                                                                      *
* InBuff32																					*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl InBuff32(
				UINT8						*bufferPtr,
				void                 *busTag,
				const void				*ioAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux InBuff32 parm [EDI] [EAX] [EDX] [ECX];

#pragma	aux InBuff32 = \
	0xF3 0x6D                        	/* rep	insd							*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDI] [EAX] [EDX] [ECX] \
	modify exact [EAX ECX EDX EDI];

#endif

/**********************************************************************\
*                                                                      *
* MapBusMemory    																		*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MapBusMemory(
				void			*busTag1,
				const void	*memAddr,
				void			*busTag2,
				void			**mappedAddr,
				UINT32		len);

/**********************************************************************\
*                                                                      *
* MovFastFromBus  																		*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MovFastFromBus(
				void				*destAddr,
				void           *srcBusTag,
				void		 		*reserved,
				const void		*srcAddr,
				UINT32			count);

#ifdef _WATCOMC_
#pragma aux MovFastFromBus parm [EDI] [EAX] [EDX] [ESI] [ECX]

#pragma aux MovFastFromBus = \
	0x8B 0xC1                         	/* mov	eax, ecx 					*/ \
	0xC1 0xE9 0x02                      /* shr	ecx, 2						*/ \
	0xF3 0xA5                        	/* rep	movsd							*/ \
	0x8B 0xC8                         	/* mov	ecx, eax 					*/ \
	0x83 0xE1 0x03                      /* and	ecx, 3						*/ \
	0xF3 0xA4                        	/* rep	movsb 						*/	\
	0xB8 0x00 0x00 0x00 0x00            /* mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDI] [EAX] [EDX] [ESI] [ECX] \
	modify exact [EAX ESI EDI ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* MovFastToBus																			*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MovFastToBus(
				void						*destBusTag,
				void						*reserved,
				void						*destAddr,
				const void				*srcAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux MovFastToBus parm [EDX] [EAX] [EDI] [ESI] [ECX]

#pragma aux MovFastToBus = \
	0x8B 0xC1                         	/* mov	eax, ecx 					*/ \
	0xC1 0xE9 0x02                      /* shr	ecx, 2						*/ \
	0xF3 0xA5                        	/* rep	movsd							*/ \
	0x8B 0xC8                         	/* mov	ecx, eax 					*/ \
	0x83 0xE1 0x03                      /* and	ecx, 3						*/ \
	0xF3 0xA4                        	/* rep	movsb 						*/	\
	0xB8 0x00 0x00 0x00 0x00            /* mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDX] [EAX] [EDI] [ESI] [ECX] \
	modify exact [EAX ESI EDI ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* MovFromBus8																				*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MovFromBus8(
				void						*destAddr,
				void                 *srcBusTag,
				void						*reserved,
				const void				*srcAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux MovFromBus8 parm [EDI] [EDX] [EAX] [ESI] [ECX]

#pragma aux MovFromBus8 = \
	0xF3 0xA4                        	/* rep	movsb							*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDI] [EDX] [EAX] [ESI] [ECX] \
	modify exact [EAX ESI EDI ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* MovFromBus16																			*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MovFromBus16(
				void						*destAddr,
				void                 *srcBusTag,
				void						*reserved,
				const void				*srcAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux MovFromBus16 parm [EDI] [EDX] [EAX] [ESI] [ECX]

#pragma aux MovFromBus16 = \
	0xF3 0x66 0xA5                  	/* rep	movsw							*/ \
	0xB8 0x00 0x00 0x00 0x00        /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDI] [EDX] [EAX] [ESI] [ECX] \
	modify exact [EAX ECX EDX EDI ESI];

#endif

/**********************************************************************\
*                                                                      *
* MovFromBus32																			*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MovFromBus32(
				void						*destAddr,
				void                 *srcBusTag,
				void						*reserved,
				const void				*srcAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux MovFromBus32 parm [EDI] [EDX] [EAX] [ESI] [ECX]

#pragma aux MovFromBus32 = \
	0xF3 0xA5                     		/* rep	movsw							*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDI] [EAX] [EDX] [ESI] [ECX] \
	modify exact [EAX ESI EDI ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* MovToBus8 																				*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MovToBus8(
				void                 *destBusTag,
				void						*reserved,
				void						*destAddr,
				const void				*srcAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux MovToBus8 parm [EDX] [EAX] [EDI] [ESI] [ECX]

#pragma aux MovToBus8 = \
	0xF3 0xA4                        	/* rep	movsb							*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDX] [EAX] [EDI] [ESI] [ECX] \
	modify exact [EDX ESI EDX EDI ECX];

#endif

/**********************************************************************\
*                                                                      *
* MovToBus16																				*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MovToBus16(
				void                 *destBusTag,
				void						*reserved,
				void						*destAddr,
				const void				*srcAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux MovToBus16 parm [EDX] [EAX] [EDI] [ESI] [ECX]

#pragma aux MovToBus16 = \
	0xF3 0x66 0xA5                     	/* rep	movsw							*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDX] [EAX] [EDI] [ESI] [ECX] \
	modify exact [EDX EAX ESI EDI ECX];

#endif

/**********************************************************************\
*                                                                      *
* MovToBus32																				*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl MovToBus32(
				void                 *destBusTag,
				void						*reserved,
				void						*destAddr,
				const void				*srcAddr,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux MovToBus32 parm [EDX] [EAX] [EDI] [ESI] [ECX]

#pragma aux MovToBus32 = \
	0xF3 0xA5                     		/* rep	movsw							*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EDX] [EAX] [EDI] [ESI] [ECX] \
	modify exact [EDX EAX ESI EDI ECX];

#endif

/**********************************************************************\
*                                                                      *
* Out8																						*
*                                                                      *
***********************************************************************/

void		_cdecl Out8(
				void                 *busTag,
				const void				*ioAddr,
				UINT8						outputVal);

#ifdef _WATCOMC_
#pragma aux Out8 parm [ECX] [EDX] [EAX];

#pragma aux Out8 = \
	0xee											/* out	dx, al */ \
	parm [ECX] [EDX] [EAX] \
	modify exact [ECX EDX EAX];

#endif

/**********************************************************************\
*                                                                      *
* Out16																						*
*                                                                      *
***********************************************************************/

void		_cdecl Out16(
				void                 *busTag,
				const void				*ioAddr,
				UINT16					outputVal);

#ifdef _WATCOMC_
#pragma aux Out16 parm [ECX] [EDX] [EAX];

#pragma aux Out16 = \
	0x66	0xef									/* out	dx, ax */ \
	parm [ECX] [EDX] [EAX] \
	modify exact [ECX EDX EAX];

#endif

/**********************************************************************\
*                                                                      *
* Out32																						*
*                                                                      *
***********************************************************************/

void		_cdecl Out32(
				void                 *busTag,
				const void				*ioAddr,
				UINT32					outputVal);

#ifdef _WATCOMC_
#pragma aux Out32 parm [ECX] [EDX] [EAX];

#pragma aux Out32 = \
	0xef											/* out	dx, eax */ \
	parm [ECX] [EDX] [EAX] \
	modify exact [ECX EDX EAX];

#endif

/**********************************************************************\
*                                                                      *
* OutBuff8																					*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl OutBuff8(
				void                 *BusTag,
				void						*ioAddr,
				const void				*buffer,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux OutBuff8 parm [EAX] [EDX] [ESI] [ECX];

#pragma aux OutBuff8 = \
	0xF3	0x6E                        	/* rep	outsb 						*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EAX] [EDX] [ESI] [ECX] \
	modify exact [EAX ESI ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* OutBuff16																				*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl OutBuff16(
				void                 *busTag,
				void						*ioAddr,
				const void				*buffer,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux OutBuff16 parm [EAX] [EDX] [ESI] [ECX];

#pragma aux OutBuff16 = \
	0xF3	0x66 0x6F                     /* rep	outsw 						*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EAX] [EDX] [ESI] [ECX] \
	modify exact [EAX ESI ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* OutBuff32																				*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl OutBuff32(
				void                 *busTag,
				void						*ioAddr,
				const void				*buffer,
				UINT32					count);

#ifdef _WATCOMC_
#pragma aux OutBuff32 parm [EAX] [EDX] [ESI] [ECX];

#pragma aux OutBuff32 = \
	0xF3	0x6F                     		/* rep	outsd 						*/ \
	0xB8 0x00 0x00 0x00 0x00            /*	mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EAX] [EDX] [ESI] [ECX] \
	modify exact [EAX ESI ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* Rd8																						*
*                                                                      *
***********************************************************************/

UINT8	_cdecl Rd8(
			void                    *busTag,
			void							*reserved,
			const void					*memAddr);

#ifdef _WATCOMC_
#pragma aux Rd8 parm [ECX] [EDX] [EAX];

#pragma aux Rd8 = \
	0x0F 0xB6 0x00                      /* movzx	eax, byte ptr [eax]		*/ \
	parm [ECX] [EDX] [EAX] \
	modify exact [EAX ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* Rd16																						*
*                                                                      *
***********************************************************************/

UINT16	_cdecl Rd16(
			void                    *busTag,
			void							*reserved,
			const void					*memAddr);

#ifdef _WATCOMC_
#pragma aux Rd16 parm [ECX] [EDX] [EAX];

#pragma aux Rd16 = \
	0x0F 0xB7 0x00                      /* movzx	eax, word ptr [eax]		*/ \
	parm [ECX] [EDX] [EAX] \
	modify exact [EAX ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* Rd32																						*
*                                                                      *
***********************************************************************/

UINT32	_cdecl Rd32(
			void                    *busTag,
			void							*reserved,
			const void					*memAddr);

#ifdef _WATCOMC_
#pragma aux Rd32 parm [ECX] [EDX] [EAX];

#pragma aux Rd32 = \
	0x8B 0x00                      		/* mov	eax, [eax]					*/ \
	parm [ECX] [EDX] [EAX] \
	modify exact [EAX ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* Set8																						*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl Set8(
			void                    *busTag,
			void							*reserved,
			const void					*memAddr,
			UINT8							value,
			UINT32						count);

#ifdef _WATCOMC_
#pragma aux Set8 parm [EBX] [EDX] [EDI] [EAX] [ECX];

#pragma aux Set8 = \
	0xF3 0xAA                        	/* rep	stosb 						*/ \
	0xB8 0x00 0x00 0x00 0x00            /* mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EBX] [EDX] [EDI] [EAX] [ECX] \
	modify exact [EAX EBX ECX EDX EDI];

#endif

/**********************************************************************\
*                                                                      *
* Set16																						*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl Set16(
			void                    *busTag,
			void							*reserved,
			const void					*memAddr,
			UINT16						value,
			UINT32						count);

#ifdef _WATCOMC_
#pragma aux Set16 parm [EBX] [EDX] [EDI] [EAX] [ECX];

#pragma aux Set16 = \
	0xF3 0x66 0xAB                     	/* rep	stosw 						*/ \
	0xB8 0x00 0x00 0x00 0x00            /* mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EBX] [EDX] [EDI] [EAX] [ECX] \
	modify exact [EAX EBX ECX EDX EDI];

#endif

/**********************************************************************\
*                                                                      *
* Set32																						*
*                                                                      *
***********************************************************************/

ODI_NBI	_cdecl Set32(
			void                    *busTag,
			void							*reserved,
			const void					*memLogicalAddr,
			UINT32						value,
			UINT32						count);

#ifdef _WATCOMC_
#pragma aux Set32 parm [EBX] [EDX] [EDI] [EAX] [ECX];

#pragma aux Set32 = \
	0xF3 0xAB                     		/* rep	stosd 						*/ \
	0xB8 0x00 0x00 0x00 0x00            /* mov	eax, ODI_NBI_SUCCESSFUL	*/ \
	parm [EBX] [EDX] [EDI] [EAX] [ECX] \
	modify exact [EAX EBX ECX EDX EDI];

#endif

/**********************************************************************\
*                                                                      *
* Slow																						*
*                                                                      *
***********************************************************************/

void	_cdecl Slow(void);

/**********************************************************************\
*                                                                      *
* Wrt8																						*
*                                                                      *
***********************************************************************/

void	_cdecl Wrt8(
			void                    *busTag,
			void							*reserved,
			void							*memAddr,
			UINT8							writeVal);

#ifdef _WATCOMC_
#pragma aux Wrt8 parm [EBX] [EDX] [ECX] [EAX];

#pragma aux Wrt8 = \
	0x88 0x01                         	/* mov	[ecx], al 					*/ \
	parm [EBX] [EDX] [ECX] [EAX] \
	modify exact [EAX EBX ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* Wrt16																						*
*                                                                      *
***********************************************************************/

void	_cdecl Wrt16(
			void                    *busTag,
			void							*reserved,
			void							*memAddr,
			UINT16						writeVal);

#ifdef _WATCOMC_
#pragma aux Wrt16 parm [EBX] [EDX] [ECX] [EAX];

#pragma aux Wrt16 = \
	0x66 0x89 0x01                      /* mov	[ecx], ax 					*/ \
	parm [EBX] [EDX] [ECX] [EAX] \
	modify exact [EAX EBX ECX EDX];

#endif

/**********************************************************************\
*                                                                      *
* Wrt32																						*
*                                                                      *
***********************************************************************/

void	_cdecl Wrt32(
			void                    *busTag,
			void							*reserved,
			void							*memAddr,
			UINT32						writeVal);

#ifdef _WATCOMC_
#pragma aux Wrt32 parm [EBX] [EDX] [ECX] [EAX];

#pragma aux Wrt32 = \
	0x89 0x01                      		/* mov	[ecx], eax 					*/ \
	parm [EBX] [EDX] [ECX] [EAX] \
	modify exact [EAX EBX ECX EDX];

#endif

/***********************************************************************\
*                                                                       *
* UnMaskBusInterrupt    	 															*
*                                                                       *
************************************************************************/

UINT32	_cdecl UnMaskBusInterrupt(
				void                 *busTag,
				UINT8					interrupt);

#ifdef _WATCOMC_

void EnableHardwareInterrupt(void);

#pragma aux UnMaskBusInterrupt parm [EAX] [ECX];

#pragma aux UnMaskBusInterrupt = \
   "call    EnableHardwareInterrupt"		\
	parm [EAX] [ECX]								\
	modify exact [EAX ECX];

#endif

/***********************************************************************\
*                                                                       *
* MaskBusInterrupt      	 															*
*                                                                       *
************************************************************************/

UINT32	_cdecl MaskBusInterrupt(
				void                 *busTag,
				UINT8					interrupt);

#ifdef _WATCOMC_

void   DisableHardwareInterrupt (void);

#pragma aux MaskBusInterrupt parm [EAX] [ECX];

#pragma aux MaskBusInterrupt = \
   "call    DisableHardwareInterrupt"	\
	parm [EAX] [ECX]							\
	modify exact [EAX ECX];

#endif

#ifdef OS_NT
#pragma pack(1)
#endif
/* GetConfigInfo was here */

/* NBIConfiguration structure definition	*/

typedef struct NBIConfiguration
{
	UINT16 NBIConfigTableMajorVer;
	UINT16 NBIConfigTableMinorVer;
	UINT8 *NBILongNamePtr;
	UINT8 *NBIShortNamePtr;
	UINT16 NBIModuleMajorVer;
	UINT16 NBIModuleMinorVer;
	UINT16 NBIInterfaceLevelMajorVer;
	UINT16 NBIInterfaceLevelMinorVer;
	UINT32 NBIConfigTableReserved0;
	UINT32 NBIConfigTableReserved1;
	UINT32 NBIConfigTableReserved2;
	UINT32 NBIConfigTableReserved3;
} NBIConfiguration;

/***************************************************************
 PlugNPlay Config Structure				        
***************************************************************/

typedef struct _CMSM_PNP_ISA_CONFIG_INFO_ {
	UINT32 	CPNPBusID;                
	UINT32	CPNPDeviceID;             
	UINT32	CPNPSerialNumber;         
	UINT32	CPNPLogicalID;            
	UINT32	CPNPFlags;                
	UINT8		CNPCSN;     	           
	UINT8		CPNPLogicalDevNum;        
	UINT16	CPNPReadDataPort;         
	UINT16 	CPNPNumMemWindows;        
	UINT32	CPNPMemBase[CMAX_MEM_REGS];
	UINT32	CPNPMemLength[CMAX_MEM_REGS]; 
	UINT16	CPNPMemAttrib[CMAX_MEM_REGS]; 
	UINT16	CPNPNumIOPorts; 
	UINT16	CPNPIOPortBase[CMAX_IO_PORTS]; 
	UINT8		CPNPIOPortLength[CMAX_IO_PORTS]; 
	UINT16	CPNPNumIRQs;      
	UINT8		CPNPIRQRegisters[CMAX_IRQS]; 
	UINT8		CPNPIRQAttrib[CMAX_IRQS]; 
	UINT16	CPNPNumDMAs;      
	UINT8		CPNPDMAList[CMAX_DMAS]; 
	UINT16	CPNPDMAAttrib[CMAX_DMAS]; 
	UINT8		CPNPVendorDefined[CMAX_VDS];  
} CMSM_PNP_ISA_CONFIG_INFO;

/* NBIRequest() verbs */

#define NBIVERB_MAP_HIN_TO_HINNAME		0x0d
#define NBIVERB_MAP_HINNAME_TO_HIN		0x0e

#define	MAX_HIN_NAME_SIZE				128

typedef struct _ODI_NBI_HIN_NAME_INFO_
{
   UINT16		size; 						/* size of this structure */
   UINT16		verb; 						/* NBIVERB_MAP_HIN_TO_HINNAME or
					  		 					NBIVERB_MAP_HINNAME_TO_HIN */
   ODI_NBI		rcode;						/* function return value from NBIRequest */
   UINT16		hin; 						/* input or output depending on verb */
   MEON_STRING	hinName[MAX_HIN_NAME_SIZE]; /* output or input depending on verb */
} ODI_NBI_HIN_NAME_INFO;


#ifdef OS_NT
#pragma pack()
#endif

#endif				/* End of File */

